/// <reference types="node" />
import * as fs from './fs';
export * from './fs';
declare type PathLike = fs.PathLike;
export declare function readdir(dir: PathLike): Promise<string[]>;
export declare function rename(source: PathLike, target: PathLike): Promise<unknown>;
export declare function remove(path: PathLike): Promise<void>;
export interface RemoverResult extends Promise<void> {
    cancel(): void;
}
export declare function remover(path: string): RemoverResult;
export declare function exists(path: PathLike): Promise<boolean>;
export declare function mkdirp(path: string, mode?: fs.MkdirOptopns): Promise<void>;
export declare function stat(path: PathLike): Promise<fs.Stats>;
