/// <reference types="node" />
export declare enum types {
    reserved = 0,
    connect = 1,
    connack = 2,
    publish = 3,
    puback = 4,
    pubrec = 5,
    pubrel = 6,
    pubcomp = 7,
    subscribe = 8,
    suback = 9,
    unsubscribe = 10,
    unsuback = 11,
    pingreq = 12,
    pingresp = 13,
    disconnect = 14,
    reserve = 15
}
declare class CONSTANTS {
    readonly types: typeof types;
    readonly CMD_SHIFT = 4;
    readonly CMD_MASK = 240;
    readonly DUP_MASK = 8;
    readonly QOS_MASK = 3;
    readonly QOS_SHIFT = 1;
    readonly RETAIN_MASK = 1;
    readonly LENGTH_MASK = 127;
    readonly LENGTH_FIN_MASK = 128;
    readonly SESSIONPRESENT_MASK = 1;
    readonly SESSIONPRESENT_HEADER: Buffer;
    readonly CONNACK_HEADER: Buffer;
    readonly USERNAME_MASK = 128;
    readonly PASSWORD_MASK = 64;
    readonly WILL_RETAIN_MASK = 32;
    readonly WILL_QOS_MASK = 24;
    readonly WILL_QOS_SHIFT = 3;
    readonly WILL_FLAG_MASK = 4;
    readonly CLEAN_SESSION_MASK = 2;
    readonly CONNECT_HEADER: Buffer;
    readonly PUBLISH_HEADER: Buffer[][][];
    readonly SUBSCRIBE_HEADER: Buffer[][][];
    readonly UNSUBSCRIBE_HEADER: Buffer[][][];
    readonly ACKS: {
        unsuback: Buffer[][][];
        puback: Buffer[][][];
        pubcomp: Buffer[][][];
        pubrel: Buffer[][][];
        pubrec: Buffer[][][];
    };
    readonly SUBACK_HEADER: Buffer;
    readonly VERSION3: Buffer;
    readonly VERSION4: Buffer;
    readonly QOS: Buffer[];
    readonly EMPTY: {
        pingreq: Buffer;
        pingresp: Buffer;
        disconnect: Buffer;
    };
    private genHeader;
}
declare const _default: CONSTANTS;
export default _default;
