import { Database, Callback, Options } from '../db';
import { Query } from './query';
import { Constants, Packet } from './parser';
export declare class ErrorPacket extends Packet {
    error: Error;
    type: Constants;
    constructor(err: Error);
    toJSON(): Error;
}
export declare class Mysql extends Database {
    private _queue;
    private _connection;
    private _connecting;
    private _transaction;
    private _close;
    private _handlError;
    private _handlePacket;
    private _after;
    private _connect;
    private _write;
    private _exec;
    private _enqueue;
    private _dequeue;
    /**
        * is connection
        */
    get connected(): boolean;
    /**
        * constructor function
        */
    constructor(options?: Options);
    statistics(cb: Callback): void;
    query(sql: string, cb?: Callback): Query;
    close(): void;
    transaction(): void;
    commit(): void;
    rollback(): void;
}
