import { Service } from './service';
/**
 * @class Session
 */
export declare class Session {
    private m_service;
    /**
     * Conversation token
     * @type {Number}
     */
    readonly token = 0;
    /**
     * constructor
     * @param {Service} service HttpService or SocketService
     * @constructor
     */
    constructor(service: Service);
    /**
     * get session value by name
     * @param  {String} name session name
     * @return {String}
     */
    get(name: string): any;
    /**
     * set session value
     * @param {String} name
     * @param {String} value
     */
    set(name: string, value: string): void;
    /**
     * delete session
     * @param {String} name
     */
    del(name: string): void;
    /**
     * get all session
     * @return {Object}
     */
    getAll(): any;
    /**
     * delete all session
     */
    delAll(): void;
}
